/*
$Id: d_dec.h,v 1.1.1.1 1998/07/21 10:27:53 rene Exp $
*/
#ifndef DECIMAL_H
#define DECIMAL_H

#ifndef DECSIZE

/** DEFINES */
#define DECSIZE 16
#define DECUNKNOWN -2
#define DECPOSNULL (-1)       

#define DECDGTTYPE signed char
struct decimal { 
  short dec_exp;         
  short dec_pos;         
  short dec_ndgts;       
  DECDGTTYPE dec_dgts[DECSIZE];      
};

#ifndef FGLDEC
#define FGLDEC
typedef struct decimal dec_t;
#endif

extern const dec_t dec0;
extern const dec_t dec1;
extern const dec_t decm1;
extern const dec_t decnull;

/** PSEUDO FUNCTIONS */
/* declen, sig = # of significant digits, rd # digits to right of decimal,
           returns # bytes required to hold such */
#define DECLEN( sig,rd )  (( (sig) + ( (rd)&1 ) + 3 ) / 2 )
#define DECLENGTH( len )  DECLEN( PRECTOT( len ), PRECDEC( len ))
#define DECPREC( size )   (( size - 1 ) << 9 ) + 2 )
#define PRECTOT( len )  ( (( len ) >> 8 ) & 0xff )
#define PRECDEC( len )  ( (( len ) & 0xff )
#define PRECMAKE( len,dlen )  (( (len) << 8 ) + (dlen) )

/*
** value of an integer that generates a decimal flagged DECPOSNULL
**     an int of 2 bytes produces 0x8000
**     an int of 4 bytes produces 0x80000000
*/

#define VAL_DECPOSNULL(type)	((unsigned long)1L << ((sizeof(type)*8) - 1))

int pdecpow(const dec_t *,int exp, dec_t *);
int pdecadd(const dec_t *,const dec_t *, dec_t *);
int pdecdiv(const dec_t *,const dec_t *, dec_t *);
int pdecmul(const dec_t *,const dec_t *, dec_t *);
int pdecsub(const dec_t *,const dec_t *, dec_t *);
int pdeccmp(const dec_t *,const dec_t *);
int pdecround(const dec_t *,      dec_t *, int at);
int pdecneg(const dec_t *,dec_t *);
int decRound(dec_t*,int dgts,int komma);

int pdeccvint(int, dec_t *);
int pdeccvshort(short i,dec_t *dp);
int pdectoint(const dec_t *, int *);
int decToShort(const dec_t *dp,short *ip);
int decToLong(const dec_t *dp,long *ip);
int pdeccvdbl(double, dec_t *);
int pdectodbl(const dec_t *, double *);
int pdeccvflt(float, dec_t *);
int pdectoflt(const dec_t *, float *);

#endif
#endif
